// Copyright (c) 2013-2016 mogemimi. Distributed under the MIT license.

#pragma once

#include "Renderable.hpp"
#include "Pomdog.Experimental/Rendering/Commands/SpriteCommand.hpp"
#include "Pomdog/Math/Rectangle.hpp"
#include "Pomdog/Math/Vector2.hpp"
#include <Pomdog/Pomdog.hpp>
#include <memory>

namespace Pomdog {

class SpriteRenderable: public Renderable {
public:
    explicit SpriteRenderable(std::shared_ptr<Texture2D> const& texture);

    SpriteRenderable(std::shared_ptr<Texture2D> const& texture, TextureRegion const& textureRegion);

    void Visit(Entity & entity, Renderer & renderer) override;

    void OriginPivot(Vector2 const& originPivot);
    Vector2 OriginPivot() const;

    void Region(TextureRegion const& region);
    TextureRegion const& Region() const;

    Rectangle BoundingBox() const;

private:
    Detail::Rendering::SpriteCommand command;
    Matrix3x2 offsetMatrix;
    Vector2 originPivot;
    std::uint32_t dirtyFlags;
};

} // namespace Pomdog
