// Copyright (c) 2013-2016 mogemimi. Distributed under the MIT license.

#pragma once

#include "Pomdog/Logging/LogLevel.hpp"
#include "Pomdog/Basic/Export.hpp"
#include "Pomdog/Signals/Signal.hpp"
#include <functional>
#include <string>

namespace Pomdog {

class LogEntry;

class POMDOG_EXPORT LogChannel {
public:
    explicit LogChannel(std::string const& name);

    LogChannel() = default;
    LogChannel(LogChannel const&) = delete;
    LogChannel(LogChannel &&) = default;
    LogChannel & operator=(LogChannel const&) = delete;
    LogChannel & operator=(LogChannel &&) = default;

    void Log(std::string const& message, LogLevel verbosity);

    void Log(LogEntry const& logEntry);

    Connection Connect(std::function<void(LogEntry const&)> const& slot);

    Connection Connect(std::function<void(LogEntry const&)> && slot);

    std::string const& Name() const;

    LogLevel Level() const;

    void Level(LogLevel level);

    std::size_t ConnectionCount() const;

private:
    Signal<void(LogEntry const&)> signal;
    std::string name;
    LogLevel level;
};

} // namespace Pomdog
