// Copyright (c) 2013-2016 mogemimi. Distributed under the MIT license.

#pragma once

#include <cstddef>

namespace Pomdog {
namespace Detail {

class NativeBuffer {
public:
    NativeBuffer() = default;
    NativeBuffer(NativeBuffer const&) = delete;
    NativeBuffer & operator=(NativeBuffer const&) = delete;

    virtual ~NativeBuffer() = default;

    virtual void GetData(std::size_t offsetInBytes,
        void* destination, std::size_t sizeInBytes) const = 0;

    virtual void SetData(std::size_t offsetInBytes,
        void const* source, std::size_t sizeInBytes) = 0;
};

} // namespace Detail
} // namespace Pomdog
